<template>
  <q-card>
    <div class="row q-pa-md text-white bg-primary">ВХОД</div>
    <q-card-section>
      <q-form
        autofocus
        class="q-gutter-md"
        @submit.prevent="step === 1 ? sendSMS : login"
      >
        <q-input
          v-if="step === 1"
          v-model="phone"
          autofocus
          dense
          clearable
          placeholder="+7-XXX-XXX-XXXX"
          type="tel"
          mask="+7-XXX-XXX-XXXX"
          :model-value="phone"
          ref="phone"
          @submit="sendSMS"
          @keyup.enter="sendSMS"
        />
        <q-input
          v-if="step === 2"
          v-model="code"
          autofocus
          dense
          clearable
          placeholder="Код из SMS"
          mask="XXXX"
          :model-value="code"
          @keyup.enter="login"
          ref="code"
        />
        <q-btn
          v-if="step === 2"
          class="q-mt-sm"
          color="primary"
          label="Назад"
          @click="step = 1"
        />
        <q-btn
          v-if="step === 1"
          class="q-mt-sm"
          :disabled="validatePhone"
          color="primary"
          label="Далее"
          :loading="loading"
          @click="sendSMS"
        />
        <q-btn
          v-if="step === 2"
          class="q-mt-sm"
          :disabled="validateCode"
          color="primary"
          label="Войти"
          :loading="loading"
          @click="login"
        />
      </q-form>
    </q-card-section>
  </q-card>
</template>

<script>
export default {
  name: 'Login',
  emits: ['closeDialog'],
  data() {
    return {
      phone: '',
      code: '',
      step: 1,
      loading: false,
    }
  },
  computed: {
    validatePhone() {
      return !this.phone || !this.phone.match(/^(\+7)-\d{3}-\d{3}-\d{4}$/)
    },
    validateCode() {
      return !this.code || !this.code.match(/^\d{4}$/)
    },
  },
  methods: {
    async sendSMS() {
      this.loading = true
      const res = await this.$store.dispatch('user/sendSMSCode', {
        phone: this.phone.replaceAll('-', ''),
      })
      this.loading = false
      if (res) this.step = 2
      else this.$refs.phone.focus()
    },
    async login() {
      this.loading = true
      const res = await this.$store.dispatch('user/login', {
        phone: this.phone.replaceAll('-', ''),
        smsCode: this.code,
      })
      this.loading = false
      if (!res) this.$refs.code.focus()
      else {
        this.step = 3

        this.$emit('closeDialog')
        await this.$router.push('/account')
      }
    },
  },
}
</script>
